#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#define RAND_MAX 32112656

int strLen(char * str);
bool strEql(char * str1, char * str2);
char * randKey(int len);
int randInt(int low, int high, int base);

int main(int argc, char * argv[]) {
HANDLE hinFile,houtFile,hkeyFile;
int i,j;
DWORD dwRead;
bool invalid = false;
int inLen = 0;
char * key = 0, * keyFile = 0, * input = 0, * inFile = 0, * output, * outFile = 0;
int keyLen = 0;
for (i=0;i<argc;i++) {
if (strEql(argv[i],"-k") && i < argc - 1) {
key = new char[strLen(argv[i+1]) + 1];
sscanf(argv[i+1], "%s", key);
}
if (strEql(argv[i],"-kf") && i < argc - 1) {
keyFile = new char[strLen(argv[i+1]) + 1];
sscanf(argv[i+1], "%s", keyFile);
}
if (strEql(argv[i],"-i") && i < argc - 1) {
inLen = strLen(argv[i+1]);
input = new char[inLen + 1];
sscanf(argv[i+1], "%s", input);
}
if (strEql(argv[i],"-if") && i < argc - 1) {
inFile = new char[strLen(argv[i+1]) + 1];
sscanf(argv[i+1], "%s", inFile);
}
if (strEql(argv[i],"-of") && i < argc - 1) {
outFile = new char[strLen(argv[i+1]) + 1];
sscanf(argv[i+1], "%s", outFile);
}
if (strEql(argv[i],"-kl") && i < argc - 1) {
sscanf(argv[i+1], "%d", &keyLen);
}
if (i >= argc - 1 && (strEql(argv[i],"-k") || strEql(argv[i],"-kf") || strEql(argv[i],"-i") || strEql(argv[i],"-if") || strEql(argv[i],"-of") || strEql(argv[i],"-kl"))) invalid = true;
}
if ((input != 0 && inFile != 0) || (input == 0 && inFile == 0)) invalid = true;
if ((key != 0 && keyFile != 0) || (key != 0 &&  keyLen != 0) || (keyFile != 0 && keyLen != 0)) invalid = true;
if (invalid) {
printf("Incorrect syntax. The proper usage is as follows.\n\nxorenc options...\n\n-i\t\tInput String\n-if\t\tInput File\n-of\t\tOutput File (If not specified, output will be printed to\n\t\tscreen)\n-k\t\tKey String\n-kf\t\tKey File\n-kl\t\tKey Length - Default is 16 (Somewhat secure)\n\nPlease note that either -i or -if must be specified, but not both. Also, not\nmore than one of -k, -kf, or -kl can be specified.\n");
return 0;
}
if (inFile != 0) {
hinFile = CreateFile(inFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, NULL);
if (hinFile == INVALID_HANDLE_VALUE) {
printf("XOR Crypt could not read from the input file specified with -if. Using -if parameter as raw input instead of as a path to an input file.\n");
inLen = strLen(inFile);
input = new char[inLen + 1];
sscanf(inFile, "%s", input);
} else {
inLen = GetFileSize(hinFile, NULL);
input = new char[inLen + 1];
ReadFile(hinFile, input, inLen, &dwRead, NULL);
input[inLen] = '\0';
CloseHandle(hinFile);
}}

if (keyFile != 0) {
hkeyFile = CreateFile(keyFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, NULL);
if (hkeyFile == INVALID_HANDLE_VALUE) {
printf("XOR Crypt could not read from the key file specified with -kf. Using -kf parameter as raw key instead of as a path to an key file.\n");
key = new char[strLen(keyFile) + 1];
sscanf(keyFile, "%s", key);
} else {
int fileLen = GetFileSize(hkeyFile, NULL);
key = new char[fileLen + 1];
ReadFile(hkeyFile, key, fileLen, &dwRead, NULL);
key[fileLen] = '\0';
CloseHandle(hkeyFile);
}}
output = new char[inLen + 1];
if (key != 0) keyLen = strLen(key);
if (key == 0) {
if (keyLen == 0) keyLen = 16;
key = randKey(keyLen);
}
for (i=0;i<inLen;i++) {
output[i] = input[i] ^ key[i % strLen(key)];
}
output[inLen] = '\0';
if (outFile != 0) {
houtFile = CreateFile(outFile, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_ARCHIVE, NULL);
WriteFile(houtFile, output, inLen, &dwRead, NULL);
CloseHandle(houtFile);
} else {
printf("Output: %s\n", output);
}
delete [] key;
delete [] keyFile;
delete [] input;
delete [] inFile;
delete [] output;
delete [] outFile;
return 0;
}

int strLen(char * str) {
int i;
for (i=0;i!=-1;i++) {
if (str[i] == '\0') return i;
}
return -1;
}

bool strEql(char * str1, char * str2) {
int i;
for (i=0;i<=strLen(str1);i++) {
if (str1[i] != str2[i]) return false;
}
return true;
}

char * randKey(int len) {
int i;
char * out = new char[len + 1];
printf("Key: ");
for (i=0;i<len;i++) {
int temp = randInt(1,62,i);
if (temp >= 1 && temp <= 10) out[i] = temp + 47;
if (temp >= 11 && temp <= 36) out[i] = temp + 54;
if (temp >= 37 && temp <= 62) out[i] = temp + 60;
printf("%c", out[i]);
}
out[len] = '\0';
printf("\n");
return out;
}

int randInt(int low, int high, int base) {
srand(GetTickCount() * (base + 27362) * 342);
int ret = rand() % (high - low + 1) + low;
return ret;
}
